/* Anastasiya Lazareva
MAT 259 Winter 2015
Homework 2 */

import java.util.*;

//file names
private String data_filename = "big_data_no_comics.csv";
//private String data_filename = "big_data.csv";
private String names_filename = "dewey_names.csv";
private String sub_cat_filename = "dewey_subclasses.csv";

//data structures
private String[][] rawdata;
private String[][] catNames;
private String[][] subCatNames;
private int[][] localMax;
private HashMap<String,Integer> adjList;

//display elements
PImage orb;
int w=1600;
int h=1100;
int padright=60;
int padtop=10;
LegendGroup group1;
LegendGroup group2;

//helper variables
private int max;
private boolean zoom;

//fonts
PFont font;
PFont fontLarge;
PFont fontItalic;


void setup(){
  size(w,h);
  smooth();
  colorMode(HSB,360,100,100,100);
  zoom = false;

  
  font=loadFont("HelveticaNeue-Light-14.vlw");
  fontLarge=loadFont("HelveticaNeue-Bold-36.vlw");
  fontItalic =loadFont("HelveticaNeue-LightItalic-14.vlw");
 
//load files
  orb=loadImage("orb.png");
  rawdata=importData(data_filename);
  adjList= getAdjList(rawdata);
  localMax=findLocalMaxValues(adjList);
  catNames=importData(names_filename);
  subCatNames=importData(sub_cat_filename);
  
  max = (Collections.max(adjList.values()))/2;
  setupLegend();
 
  
  println("total "+rawdata.length);
  println("max co-occurance "+max);
  println("size "+ adjList.size());
  println("Total size "+  rawdata.length);
}


void setupLegend(){
   group1= new LegendGroup(catNames.length);
   group2= new LegendGroup(catNames.length);
   for (int i=0; i<catNames.length;i++){
   LegendItem item1= new LegendItem(group1, i,1000+100,140+i*25,15);
   LegendItem item2= new LegendItem(group2, i,1000+125,140+i*25,15);
   group1.addItem(item1);
   group2.addItem(item2);
   }
}

void draw(){
  background(60);
  if(group1.selected && group2.selected) zoom=true;
  else zoom=false;
  drawLegend();
  drawGrid();
  drawLabels();
  drawData();
  textFont(fontLarge,32);
  fill(360,80);
  textAlign(LEFT,TOP);
  text("Frequently Borrowed Together",padright+1000+25,55);
  textFont(fontItalic,14);
  text("use the radio buttons to zoom",padright+1000+25,100);
   
}


void drawGrid(){
  pushMatrix();
  pushStyle();
  translate(padright,padtop+(height-padtop-1000)/2);
     stroke(0,80);
     strokeWeight(1.7);
     for(int i=1;i<10;i++){
      line(100*i,0,100*i,1000);
      line(0,100*i,1000,100*i);
     }
     if (zoom){
      strokeWeight(0.5);
      for(int i=1;i<100;i++){
      line(10*i,0,10*i,1000);
      line(0,10*i,1000,10*i);
     }
     }
  strokeWeight(0.7);
  fill(0,20);
  rect(0,0,1000,1000);
  popStyle();
  popMatrix();
}


void drawLabels(){
  pushMatrix();
  pushStyle();
  translate(padright,padtop+(height-padtop-1000)/2);
    fill(250,80);
    textFont(font,14);
    
    for(int i=0;i<10;i++){
      textAlign(CENTER,TOP);
      if (!zoom) text(catNames[i][0],100*i+50,1000+10);
      else text(subCatNames[group2.selectedItem*10+i][0],100*i+50,1000+10);
     pushMatrix();
     rotate(-PI/2);
     textAlign(CENTER,BOTTOM);
      if (!zoom) text(catNames[i][0],100*i+50-1000,-10);
      else text(subCatNames[group1.selectedItem*10+i][0],100*i+50-1000,-10);       
     popMatrix();
     }
  
  popStyle();
  popMatrix();
  
}


void drawLegend(){
    //pushMatrix();
    pushStyle();
    //translate(padright+1000+150,padtop+(height-padtop-1000)/2);
    textFont(font,14);
    fill(360,80);
    for (int i=0; i<catNames.length;i++){
      textAlign(RIGHT,CENTER);
      text(catNames[i][0].replace("\"", ""),1000+200+10,140+i*25);
      textAlign(LEFT,CENTER);
      text(catNames[i][1].replace("\"", ""),1000+200+30,140+i*25);
    }
    
    if(zoom){
      for (int i=0; i<catNames.length;i++){
      textAlign(RIGHT,CENTER);
      text(subCatNames[group1.selectedItem*10+i][0].replace("\"", ""),1000+200+10,420+i*25);
      textAlign(LEFT,CENTER);
      text(subCatNames[group1.selectedItem*10+i][1].replace("\"", ""),1000+200+30,420+i*25);
      if(group2.selectedItem!=group1.selectedItem){
      textAlign(RIGHT,CENTER);
      text(subCatNames[group2.selectedItem*10+i][0].replace("\"", ""),1000+200+10,700+i*25);
      textAlign(LEFT,CENTER);
      text(subCatNames[group2.selectedItem*10+i][1].replace("\"", ""),1000+200+30,700+i*25);
      }
      }
    }

   group1.draw();
   group2.draw();
  popStyle();
  //popMatrix();
}



void drawData(){
  pushMatrix();
  pushStyle();
  imageMode(CENTER); 
  translate(padright,padtop+(height-padtop-1000)/2);
  if(zoom){
    for (String k : adjList.keySet()) {
        int val=adjList.get(k);
        String[] coords = k.split("-");
        int x_val=Integer.parseInt(coords[0]);
        int y_val=Integer.parseInt(coords[1]);
        if(floor(x_val/100.0)==group1.selectedItem && floor(y_val/100.0)==group2.selectedItem){
          float x_coord=getMappedLocation(x_val-group1.selectedItem*100);
          float y_coord=getMappedLocation(y_val-group2.selectedItem*100);
        if(group1.selectedItem==group2.selectedItem && x_coord==y_coord) val=val/2;
        int locMax=localMax[group1.selectedItem][group2.selectedItem];
        tint(175,30,100,getMappedValue(val,locMax));
        image(orb,x_coord,1000-y_coord,getMappedSize(val,locMax),getMappedSize(val,locMax));   
        }   
    }
    
  }
  
  else{

    for (String k : adjList.keySet()) {
        int val=adjList.get(k);
        String[] coords = k.split("-");
        int x_coord=Integer.parseInt(coords[0]);
        int y_coord=Integer.parseInt(coords[1]);
        if(x_coord==y_coord) val=val/2;
        tint(175,30,100,getMappedValue(val,max));
        image(orb,x_coord,1000-y_coord,getMappedSize(val,max),getMappedSize(val,max));      
    }
  }
    popStyle();
    popMatrix();
  
}

private float getMappedLocation(int p){
  return map(p,0,100,0,1000);
}

private String[][] importData(String filename){
    String[] lines = loadStrings(filename);
    int rows = lines.length;
    int cols = split(lines[0], ",").length;
    println("cols " +cols);
    String[][] data = new String[rows-1][cols];
    for (int i = 1; i < rows; i++) {
       String[] row = lines[i].split( ",(?=([^\"]*\"[^\"]*\")*[^\"]*$)");
       if (row[0]==null || row[1]==null) println("error at "+i);
        for (int j = 0; j< cols; j++) {
        data[i-1][j] = row[j].trim();
        }
    }
    return data;
  }
  

  private float getMappedValue(int v, int m){
    if (zoom) return map(v,1,m*0.9,75,85); 
    else return map(v,1,m*0.9,25,90); 
  }
  
 private float getMappedSize(int v, int m){
   if (zoom) return map(v,1,m*0.9,4,45); 
   else return map(v,1,m*0.9,2.7,45); 
  }

  
  
  private HashMap<String, Integer> getAdjList(String[][] raw){
   HashMap<String, Integer> myMap = new HashMap<String, Integer>();
   for (int i=0;i<raw.length;i++){
     String myKey = raw[i][0]+"-"+raw[i][1];
     if (myMap.get(myKey) == null)
        myMap.put(myKey,1);
     else  myMap.put(myKey,myMap.get(myKey)+1);
   } 
   return myMap;
  }
  
  private int[][] findLocalMaxValues(HashMap<String, Integer> list){
    int[][] answer= new int[10][10];
    for (int i=0; i<answer.length;i++){
      for (int j=0;j<answer[0].length;j++){
        answer[i][j]=0;
      }  
    }
   for (String k : adjList.keySet()) {
        int val=adjList.get(k);
        String[] coords = k.split("-");
        int x_val=Integer.parseInt(coords[0]);
        int y_val=Integer.parseInt(coords[1]);
        int x_idx=floor(x_val/100.0);
        int y_idx=floor(y_val/100.0);
        if (x_idx==y_idx) val=val/2;
        if (answer[x_idx][y_idx]<val) answer[x_idx][y_idx]=val;
    }
    return answer;
  }
  
  
  void keyPressed(){
    if(key == 's') save("mockup.jpg");
  }
  
  void mousePressed(){    
    group1.checkSelected(mouseX, mouseY);
    group2.checkSelected(mouseX, mouseY);
}

